//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymDecDlgs.h"
#include "NymWizDlgs.h"
#include "NymMail.h"
#include "Mixmaster.h"
#include "PgpFiles.h"
#include "FileMan.h"
#include "View.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNymDecDlg *NymDecDlg;
//---------------------------------------------------------------------------
__fastcall TNymDecDlg::TNymDecDlg(TComponent* Owner)
   : TForm(Owner)
{
   //int max=0;
   TStringList *words,*tmp=new TStringList();
   nyms = new TStringList();
   nyms->Duplicates = dupAccept;
   bool needstrings = true;
   AnsiString nym,line,enckey;
   GetAppData(tmp,NymProfilesKey);
   TStringList *profile = new TStringList();
   while (profile->Count && profile->Strings[0].Trim().IsEmpty())
      profile->Delete(0);
   for (int n=0; n<tmp->Count-1; n++)
   {
      nym = tmp->Strings[n];
      GetAppData(profile,NymProfilesKey+PS+nym);
      profile->Add("Reply-Block:"); // add to end to trigger needstrings counting backwards
      for (int p=profile->Count-1; p>0; p--)
      {
         line = profile->Strings[p].Trim();
         if (line.Pos("Reply-Block:")==1) needstrings = true; else
         if (line.Trim().Pos("Encrypt-Key: ")==1)
         {
            if (needstrings)
            {
               nyms->AddObject(nym,words = new TStringList());
               needstrings = false;
            }
            words->Add(line.SubString(14,256));
            if (maxphrases<words->Count) maxphrases = words->Count;
         }
      }
   }
   delete profile;
   success = false;
}
//---------------------------------------------------------------------------
__fastcall TNymDecDlg::~TNymDecDlg()
{
   for (int n=0; n<nyms->Count; n++)
   {
      TList *list = dynamic_cast<TList*>(nyms->Objects[n]);
      if (list)
      {
         for (int l=0; l<list->Count; l++)
            delete (TStringList*)list->Items[l];
      }
   }
   delete nyms;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymDecDlg::GetPhrase(int nym, int phr)
{
   if (nym<0 || nym>=nyms->Count || phr<0 || phr>=maxphrases) return "";
   TStringList *phrases = dynamic_cast<TStringList*>(nyms->Objects[nym]);
   if (phrases && phr<phrases->Count)
      return phrases->Strings[phr];
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymDecDlg::GetKey(int nym, int key)
{
   if (key<0 || nym<0 || nym>=nyms->Count) return "";
   TStringList *keys = dynamic_cast<TStringList*>(nyms->Objects[key]);
   if (keys && key>=keys->Count) return "";
   if (keys) return keys->Strings[key];
   return "";
}
//---------------------------------------------------------------------------
bool __fastcall TNymDecDlg::Decrypt(TStrings *Msg)
{
   msg = Msg; ShowModal();
   return success;
}
//---------------------------------------------------------------------------
bool __fastcall TNymDecDlg::PgpDecryptConventional(TStrings *msg, AnsiString &password)
{
   BUFFER *MSG = buf_new(); BUFFER *PAS = buf_new();

   int idx;
   buf_sets(PAS,password.c_str());
   buf_sets(MSG,msg->Text.c_str());
   errcode = pgp_decrypt(MSG,PAS,NULL,NULL,NULL);
   if (errcode==PGP_OK)
   {
      msg->SetText((char*)MSG->data);
      if ((idx=msg->IndexOf(BeginPgpMessage))>=0)
      {
         for (int i=0; i<idx; i++)
            if (msg->Count) msg->Delete(0);
      }
      if ((idx=msg->IndexOf(EndPgpMessage))>=0)
      {
         while (msg->Count>idx)
            msg->Delete(msg->Count-1);
      }
   }
   buf_free(PAS);
   buf_free(MSG);
   return errcode==PGP_OK;
}
//---------------------------------------------------------------------------
void __fastcall TNymDecDlg::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TNymDecDlg::UpdateCaption(AnsiString &updateinfo)
{
   // not used
   Panel1->Caption = ""; AppProcessMessages(); Sleep(100);
   Panel1->Caption = updateinfo;
   AppProcessMessages();
   Sleep(400);
}
//---------------------------------------------------------------------------
void __fastcall TNymDecDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Sleep(300);
   bool ok = false;
   AnsiString phrase;
   int n=0,p=0; success = false;
   while(n<nyms->Count && p<maxphrases)
   {
      phrase = GetPhrase(n,p);
      if (!phrase.IsEmpty() && PgpDecryptConventional(msg,phrase))
      {
         ok = true;
         success = true;
         if (msg->IndexOf(BeginPgpMessage)<0) break;

         n = -1;
         p++;
      }
      if (n<nyms->Count) n++;
      else
      {
         if (!ok) break;
         ok = false;
         n = 0;
         p++;
      }
   }
   ModalResult = mrOk;
}
//---------------------------------------------------------------------------
/*void __fastcall TNymDecDlg::Timer1Timer(TObject *Sender)
{
   AnsiString phrase;
   Timer1->Enabled = false;
   int k=0; int n=0; OK = false;
   while(true)
   {
      phrase = GetKey(n,k); if (phrase.IsEmpty())
      {
         n++; continue;
      }
      if (PgpDecryptConventional(msg,phrase))
      {
         if (msg->IndexOf(BeginPgpMessage)<0)
         {
            OK = true;
            break;
         }
      }
      if ((errcode==PGP_PASS || errcode==PGP_ERR) && n<maxkeys) n++;
      else break;

      if (n>=nyms->Count-1) n==0;
   }
}*/
//---------------------------------------------------------------------------
