//---------------------------------------------------------------------------
#ifndef NymWizDlgsH
#define NymWizDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include "pgpbuffers.h"
#include <vcl\Menus.hpp>
#include "explbtn.hpp"
//---------------------------------------------------------------------------
bool __fastcall RunNymWiz(TForm *Owner);
AnsiString eaddr(AnsiString &userid);

class TNymProfile : public TStringList
{
public:
   __fastcall TNymProfile();
   //virtual __fastcall TNymProfile(TStrings *profile);
   void __fastcall setprofile(AnsiString Nym, AnsiString Name, AnsiString Commands, AnsiString PgpKey,
      AnsiString ReplyBlocks, AnsiString PublicKey, AnsiString SecretKey);
   AnsiString __fastcall nym();
   AnsiString __fastcall nymname();
   AnsiString __fastcall nymcommands();
   AnsiString __fastcall nympgpkey();
   AnsiString __fastcall nymreplyblocks();
   AnsiString __fastcall nympublickey();
   AnsiString __fastcall nymsecretkey();
};

class TNymWizDlg : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TButton *BackBtn;
  TButton *NextBtn;
  TButton *CancelBtn;
  TButton *HelpBtn;
  TNotebook *Notebook1;
  TLabel *Label1;
  TLabel *Label2;
  TRadioButton *CreateBtn;
  TRadioButton *ModifyBtn;
  TRadioButton *ResendBtn;
  TRadioButton *DeleteBtn;
  TLabel *Label5;
  TLabel *Label11;
  TRadioButton *RetiredBtn;
  TLabel *Label4;
  TLabel *Action1;
  TLabel *Label19;
  TLabel *Label20;
  TTimer *Timer1;
  TLabel *Label24;
  TLabel *Label10;
  TLabel *Label22;
  TLabel *Label9;
  TLabel *Label8;
  TMemo *ReplyBlock;
  TMemo *Review;
  TPopupMenu *PopupDirMenu;
  TMenuItem *PopEditDirectivesItem;
  TMenuItem *N1;
  TPopupMenu *PopupTmpMenu;
  TMenuItem *EditTemplatesItems;
  TMenuItem *N2;
  TButton *EditCmdsBtn;
  TPanel *Panel2;
  TLabel *Label7;
  TComboBox *NYMBox;
  TComboBox *NYM;
  TLabel *Label6;
  TEdit *Name;
  TRichEdit *RichEdit3;
  TPanel *Panel3;
  TLabel *Label16;
  TComboBox *PgpKey;
  TRichEdit *RichEdit5;
  TPanel *Panel4;
  TLabel *Label18;
  TRichEdit *RichEdit4;
  TLabel *Label23;
  TPanel *Panel5;
  TLabel *Label3;
  TListBox *NymsDeleteBox;
  TRichEdit *RichEdit1;
  TPanel *Panel6;
  TLabel *Label12;
  TListBox *NymsRetireBox;
  TRadioButton *ReinstateBtn;
  TRadioButton *RemoveBtn;
  TRadioButton *ReDelBtn;
  TLabel *Label13;
  TPanel *Panel7;
  TLabel *Label15;
  TListBox *NymsResendBox;
  TRadioButton *ReplayBox;
  TRichEdit *RichEdit2;
  TRadioButton *ResendBox;
  TGroupBox *GroupBox1;
	TComboBox *ViewNym;
	TRadioButton *ViewNymBtn;
	TMemo *ViewProfile;
	TLabel *Label14;
	TOfficeButton *TemplateBtn;
	TOfficeButton *OfficeButton1;
	TOfficeButton *OfficeButton2;
	TPopupMenu *PopupRemMenu;
	TOfficeButton *OfficeButton3;
  void __fastcall NextBtnClick(TObject *Sender);
  void __fastcall BackBtnClick(TObject *Sender);
  void __fastcall ReinstateBtnClick(TObject *Sender);
  void __fastcall RemoveBtnClick(TObject *Sender);
  void __fastcall ReDelBtnClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall ResendBoxClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall ReplayBoxClick(TObject *Sender);
  void __fastcall NYMBoxChange(TObject *Sender);
  void __fastcall NymsDeleteBoxClick(TObject *Sender);
  void __fastcall NymsResendBoxClick(TObject *Sender);
  void __fastcall NymsRetireBoxClick(TObject *Sender);
  void __fastcall NYMChange(TObject *Sender);
  void __fastcall RemailerBtnClick(TObject *Sender);
  void __fastcall DirectBtnClick(TObject *Sender);
  void __fastcall TemplateBtnClick(TObject *Sender);
  void __fastcall PopEditDirectivesItemClick(TObject *Sender);
  void __fastcall EditTemplatesItemsClick(TObject *Sender);
  void __fastcall BiggerBtn1Click(TObject *Sender);
  void __fastcall EditCmdsBtnClick(TObject *Sender);
  void __fastcall PutNymMessageOnDesktop(TStrings *msg);
  void __fastcall ViewNymChange(TObject *Sender);
  void __fastcall OfficeButton2Click(TObject *Sender);

	void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  //wizmode mode;
  AnsiString cap,cap1;
  TCheckBox *fingerkey;
  TNymProfile *profile;
  TStringList *nymcmds,*userids,*nymservers;
  TPGPbuffer *pubkeys,*seckeys,*remkeys,*key;
  __fastcall TNymWizDlg(TComponent* Owner);
  virtual __fastcall ~TNymWizDlg();
  void __fastcall ShowHint(TObject *Sender);
  void __fastcall SetNymPgpKeyUserIds();
  void __fastcall SetNymCommands(TStrings *cmds);
  void __fastcall ClrNymCommands();
  AnsiString __fastcall EmailAddress();
  void __fastcall FillReviewFromInput();
  void __fastcall GenProfileFromInput(TStrings *profile);
  AnsiString __fastcall PgpKeyUserId();
  void __fastcall GetNymKeyFromInput();
  void __fastcall SetFingerKeyFromInput();
  void __fastcall GetPgpKeyFromEmailAddress();
  void __fastcall GetPublicsFromSecrets(TPGPbuffer *pubs);
  AnsiString __fastcall GetPgpPubKeyIdText8(AnsiString &userid);
  AnsiString __fastcall NymCommandsStr(int breakAt=-1);
  bool __fastcall CreateNymCreateMessage(TStrings *msg);
  bool __fastcall PrepareNymCreateMessage();
  bool __fastcall CreateNymModifyMessage(TStrings *msg);
  bool __fastcall PrepareNymModifyMessage();
  bool __fastcall CreateNymDeleteMessage(TStrings *msg);
  bool __fastcall PrepareNymDeleteMessage();
  bool __fastcall PrepareNymResendMessage(); // no create needed
  void __fastcall ReinstateNymInSystem();
  void __fastcall RemoveNymFromSystem();
  void __fastcall SendNymDeleteAgain();
  void __fastcall PopupMenuItemOnClick(TObject *Sender);
  void __fastcall PopupRBTempItemOnClick(TObject *Sender);
  void __fastcall SetInputFromProfile(TNymProfile *Profile);
  void __fastcall SetInputFromNym(AnsiString nym);
  AnsiString __fastcall NymServerKeyIdText8();
  AnsiString __fastcall NymKeyIdText8();
  void __fastcall LoadRemailersMenu();
  void __fastcall LoadCpkDirectivesMenu();
  void __fastcall LoadRBTemplatesMenu();
  void __fastcall SetLabel1Caption(AnsiString Cap);
  void __fastcall StepClose();
  void __fastcall ClearAll();
  AnsiString __fastcall GetMergeMessage(AnsiString &caption, int mode);
  bool __fastcall ReplyBlocksValid(TForm *Owner, TStrings *block);
};
//---------------------------------------------------------------------------
extern TNymWizDlg *NymWizDlg;
//---------------------------------------------------------------------------
#endif
